' ***************************************************************************
' *                                                                         *
' * Title         : Simon                                                   *
' * Version       : 1.0                                                     *
' * Last Updated :  29.03.05                                                *
' * Target        : At90s2313                                               *
' * Author        : Dietrich Kindermann                                     *
' * Program code  : BASCOM AVR                                              *
' * Hardware req. : WPU Simon Board                                         *
' * Description                                                             *
' *                                                                         *
' * Simon-Spiel fr den Schleraufbau (spielt stndlich "Hey Jude" !)       *
' *                                                                         *
' ***************************************************************************

$regfile = "2313def.dat"
$crystal = 4000000

Dim Feld(20) As Byte
Dim ___rseed As Word
Dim Compval As Word
Dim Zahl As Word
Dim Anz As Byte
Dim Init As Byte
Dim Dauer As Long
Dim Ende As Byte
Dim Freq As Long
Dim Note As Long
Dim Laen As Byte
Dim Melo As Byte
Dim Mel As Byte
Dim Key As Byte
Dim Num As Byte
Dim Taste As Byte
Dim Port As Byte
Dim A As Word
Dim B As Word
Dim C As Byte

Const Be = 10
Const Maxi = 21

Declare Sub Ton(dauer As Long , Note As Long)
Declare Sub Heyjude
Declare Sub Ledtoggle
Declare Sub Ledon
Declare Sub Ledoff
Declare Sub Nton
Declare Sub Sou
Declare Sub Hit
Declare Sub Tast


Config Pinb.7 = Output                                      'LED blau
Config Pinb.6 = Output                                      'LED gelb
Config Pinb.5 = Output                                      'LED rot
Config Pinb.4 = Output                                      'LED grn

Config Pinb.2 = Input                                       'Taste grn
Config Pind.5 = Input                                       'Taste rot
Config Pind.4 = Input                                       'Taste gelb
Config Pind.3 = Input                                       'Taste blau

Config Pind.2 = Input                                       'Jumper

Config Pind.6 = Output                                      'Comparator


Config Timer1 = Timer , Prescale = 1 , Compare A = Toggle , Clear Timer = 1

Anz = 0
Init = 0
Num = 0
Ende = 0

Schl:

For A = 1 To 20000

If Init = 0 Then Call Ledtoggle


 For B = 1 To 10000

    If Pind.3 = 0 Then                                      'Taste blau
    Taste = 1
    Note = &H1000
    Port = 7
    Call Tast
   End If

   If Pind.4 = 0 Then                                       'Taste gelb
    Taste = 2
    Note = &H1250
    Port = 6
    Call Tast
   End If

   If Pind.5 = 0 Then                                       'Taste rot
    Taste = 3
    Note = &H1500
    Port = 5
    Call Tast
   End If

   If Pinb.2 = 0 Then                                       'Taste grn
    Taste = 4
    Note = &H1750
    Port = 4
    Call Tast
   End If

 Next B

If Init = 1 Then
 If A = 100 Then                                            'Spiel beenden
  Init = 0                                                  'wenn keine Taste
  Anz = 0                                                   'gedrckt wird
  Ende = 0
  Call Sou
 End If
End If

Next A

Call Heyjude

Goto Schl


'Prfen ob Taste gedrckt

Sub Hit

Key = 0
Waitms 100
If Pind.3 = 0 Then Key = 1                                  'Taste blau
If Pind.4 = 0 Then Key = 1                                  'Taste gelb
If Pind.5 = 0 Then Key = 1                                  'Taste rot
If Pinb.2 = 0 Then Key = 1                                  'Taste grn

End Sub Hit


'LED toggle

Sub Ledtoggle

Toggle Portb.7                                              'LED blau toggle
Toggle Portb.6                                              'LED gelb toggle
Toggle Portb.5                                              'LED rot toggle
Toggle Portb.4                                              'LED grn toggle

End Sub Ledtoggle


'LED off

Sub Ledoff

Set Portb.7                                                 'LED blau aus
Set Portb.6                                                 'LED gelb aus
Set Portb.5                                                 'LED rot aus
Set Portb.4                                                 'LED grn aus

End Sub Ledoff


'Taste abfragen

Sub Tast

Call Hit
If Key = 1 Then
 A = 0
 ___rseed = B
 If Anz < Maxi Then
  Anz = Anz + 1
  Zahl = Rnd(4) + 1
  Feld(anz) = Zahl
 End If
 If Init = 0 Then
  Call Sou
  Waitms 1000
  Call Nton
  Init = 1
 Else
  Reset Portb.port
  Dauer = &H125
  Call Ton(dauer , Note)
  Compare1a = 0
  Set Portb.port
  Num = Num + 1
  If Feld(num) <> Taste Then
   Call Sou
   Waitms 1000
   Ende = Ende - 2
   Call Nton
   Init = 0
   Anz = 0
   Ende = 0
  Else
   If Num = Ende Then Call Nton
  End If
 End If
End If

End Sub Tast


'Sound ausgeben

Sub Sou
Call Ledoff
For Compval = 100 To 10000 Step 100
  Compare1a = Compval
  Waitms 10
Next Compval
Compare1a = 0
End Sub Sou


'neue Tonfolge generieren

Sub Nton

Waitms 1000

 Ende = Ende + 1

 If Ende = Maxi Then
  Call Heyjude
  Ende = 0
  Init = 0
  Anz = 0
 Else
  For C = 1 To Ende

  If Feld(c) = 1 Then
   Note = &H1000
   Port = &H07
  End If
  If Feld(c) = 2 Then
   Note = &H1250
   Port = &H06
  End If
  If Feld(c) = 3 Then
   Note = &H1500
   Port = &H05
  End If
  If Feld(c) = 4 Then
   Note = &H1750
   Port = &H04
  End If

  Waitms 1000
  Reset Portb.port
  Dauer = &H125
  Call Ton(dauer , Note)
  Compare1a = 0
  Set Portb.port

  Next C

 End If

Num = 0

End Sub Nton


'Hey Jude ber Piezo-Summer ausgeben

Sub Heyjude

For A = 0 To 55
 Melo = Lookup(a , Mel)
 Laen = Lookup(a , Lae)
 Note = Lookup(melo , Fre)
 Dauer = Lookup(laen , Dau)
 Call Ton(dauer , Note)
Next A

Compare1a = 0
Waitms 4000

End Sub Heyjude


'Tonfolge ausgeben

Sub Ton(dauer , Note)

Compare1a = Note
Waitms Dauer
Set Portd.6
Waitms Be
Reset Portd.6

End Sub Ton



Mel:

Data &H05 , &H03 , &H00 , &H03 , &H00 , &H05 , &H06 , &H02 , &H00 , &H02 , &H03 , &H04 , &H00 , &H08 , &H00 , &H08 , &H00 , &H07 , &H05 , &H00 , &H06 , &H05 , &H04 , &H03 , &H00 , &H05 , &H00 , &H06 , &H06 , &H00 , &H06 , &H09 , &H08 , &H00 , &H07 , &H08 , &H06 , &H00 , &H05 , &H00 , &H01 , &H02 , &H03 , &H00 , &H06 , &H05 , &H00 , &H05 , &H04 , &H00 , &H03 , &H00 , &H02 , &H00 , &H01



'     Hey   Jude           don't         make   it     bad           take     a     sad         song           and           make   it             bet-               ter.            Re-           mem-   ber           to     let    her           in-    to    your          heart,        then   you    can          sta-     rt           and    make           it           bet-          ter.


Lae:

Data &H03 , &H05 , &H03 , &H01 , &H01 , &H01 , &H02 , &H06 , &H04 , &H01 , &H01 , &H03 , &H01 , &H04 , &H01 , &H01 , &H01 , &H01 , &H01 , &H01 , &H01 , &H01 , &H01 , &H06 , &H02 , &H01 , &H01 , &H01 , &H01 , &H03 , &H01 , &H01 , &H01 , &H01 , &H01 , &H01 , &H01 , &H01 , &H03 , &H03 , &H02 , &H01 , &H02 , &H01 , &H01 , &H03 , &H03 , &H01 , &H01 , &H01 , &H02 , &H01 , &H01 , &H01 , &H05



Fre:

Data 0& , 7645& , 6810& , 6067& , 5727& , 5102& , 4545& , 4050& , 3822& , 3405&
'          262Hz  294Hz   330Hz   349Hz   392Hz    440Hz   494Hz   523Hz   587Hz


Dau:

Data 0& , 250& , 500& , 750& , 1000& , 1250& , 1500&
'          1/8    1/4    3/8    1/2     5/8     3/4